<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPrinting.DocumentSize ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPrinting.DocumentSize
 * @subpackage Arrays
 */
class ArrayOfPrinting_DocumentSize extends AbstractStructArrayBase
{
    /**
     * The Printing_DocumentSize
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\Printing_DocumentSize[]
     */
    public $Printing_DocumentSize;
    /**
     * Constructor method for ArrayOfPrinting.DocumentSize
     * @uses ArrayOfPrinting_DocumentSize::setPrinting_DocumentSize()
     * @param \patest\StructType\Printing_DocumentSize[] $printing_DocumentSize
     */
    public function __construct(array $printing_DocumentSize = array())
    {
        $this
            ->setPrinting_DocumentSize($printing_DocumentSize);
    }
    /**
     * Get Printing_DocumentSize value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\Printing_DocumentSize[]|null
     */
    public function getPrinting_DocumentSize()
    {
        return isset($this->{'Printing.DocumentSize'}) ? $this->{'Printing.DocumentSize'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPrinting_DocumentSize method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPrinting_DocumentSize method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePrinting_DocumentSizeForArrayConstraintsFromSetPrinting_DocumentSize(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPrinting_DocumentSizePrinting_DocumentSizeItem) {
            // validation for constraint: itemType
            if (!$arrayOfPrinting_DocumentSizePrinting_DocumentSizeItem instanceof \patest\StructType\Printing_DocumentSize) {
                $invalidValues[] = is_object($arrayOfPrinting_DocumentSizePrinting_DocumentSizeItem) ? get_class($arrayOfPrinting_DocumentSizePrinting_DocumentSizeItem) : sprintf('%s(%s)', gettype($arrayOfPrinting_DocumentSizePrinting_DocumentSizeItem), var_export($arrayOfPrinting_DocumentSizePrinting_DocumentSizeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Printing_DocumentSize property can only contain items of type \patest\StructType\Printing_DocumentSize, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Printing_DocumentSize value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\Printing_DocumentSize[] $printing_DocumentSize
     * @return \patest\ArrayType\ArrayOfPrinting_DocumentSize
     */
    public function setPrinting_DocumentSize(array $printing_DocumentSize = array())
    {
        // validation for constraint: array
        if ('' !== ($printing_DocumentSizeArrayErrorMessage = self::validatePrinting_DocumentSizeForArrayConstraintsFromSetPrinting_DocumentSize($printing_DocumentSize))) {
            throw new \InvalidArgumentException($printing_DocumentSizeArrayErrorMessage, __LINE__);
        }
        if (is_null($printing_DocumentSize) || (is_array($printing_DocumentSize) && empty($printing_DocumentSize))) {
            unset($this->Printing_DocumentSize, $this->{'Printing.DocumentSize'});
        } else {
            $this->Printing_DocumentSize = $this->{'Printing.DocumentSize'} = $printing_DocumentSize;
        }
        return $this;
    }
    /**
     * Add item to Printing_DocumentSize value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\Printing_DocumentSize $item
     * @return \patest\ArrayType\ArrayOfPrinting_DocumentSize
     */
    public function addToPrinting_DocumentSize(\patest\StructType\Printing_DocumentSize $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\Printing_DocumentSize) {
            throw new \InvalidArgumentException(sprintf('The Printing_DocumentSize property can only contain items of type \patest\StructType\Printing_DocumentSize, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Printing_DocumentSize[] = $this->{'Printing.DocumentSize'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\Printing_DocumentSize|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\Printing_DocumentSize|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\Printing_DocumentSize|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\Printing_DocumentSize|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\Printing_DocumentSize|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Printing.DocumentSize
     */
    public function getAttributeName()
    {
        return 'Printing.DocumentSize';
    }
}
